<?php
  include_once ("./controller/IController.php");
  include_once ("./model/Author.php");
  include_once ("./util/DbUtil.php");

  class AuthorEditController implements IController {
    public function execute(&$errors) {
      $id = $_REQUEST['id'];
      $author = null;

      if (isSet($id)) {
        $query = "SELECT author_id, author_name_romanji, author_name FROM manga_author" .
                " WHERE author_id = $id";

        $dao = DbUtil::getDao();
        $result = $dao->query($query);

        $author = new Author($result[0]);
      } else {
        $author = new Author(null);
      }
      return $author;
    }

    public function save(&$errors) {
      $id = $_REQUEST['id'];
      $dialect = DbUtil::getDialect();

      $nameRomanji = $dialect->escapeString($_REQUEST['nameRomanji']);
      $nameKanji = $dialect->escapeString($_REQUEST['nameKanji']);

      $author = new Author(null);
      $author->setId($id);
      $author->setNameRomanji($_REQUEST['nameRomanji']);
      $author->setNameKanji($_REQUEST['nameKanji']);

      if ($nameRomanji == "") {
        $errors->addError(new Error("nameRomanji", AbstractLocale::getInstance()->getTranslation("error_required_romanji_name")));
      }

      if ($nameKanji == "") {
        $nameKanji = "NULL";
      } else {
        $nameKanji = "'" . $nameKanji . "'";
      }
      
      $dao = DbUtil::getDao();
      if ($errors->hasErrors() == FALSE) {
        $query = "SELECT COUNT(*) AS count FROM manga_author WHERE author_name_romanji = '$nameRomanji'";
        if (isSet($id) && $id != "") {
          $query .= " AND author_id <> $id;";
        }
        $countResult = $dao->query($query);
        $count = $countResult[0]->count;

        if($count > 0) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_duplicate_reference")));
        }
      }

      if ($errors->hasErrors() == FALSE) {
        $query = "";
        if (isSet($id) && $id != "") {
          $query = "UPDATE manga_author " .
                  "SET author_name_romanji = '$nameRomanji', " .
                  "author_name = $nameKanji " .
                  "WHERE author_id = $id;";
        } else {
          $query = "INSERT INTO manga_author (author_name_romanji, author_name) values (" .
                   "'$nameRomanji', $nameKanji);";
        }

        try {
          $dao->queryUpdate($query);
          $dao->commit();
        } catch(Exception $exception) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_save")));
          $dao->rollback();
        }
      }
      return $author;
    }

  }
?>