<?php
  include_once ("./controller/IController.php");
  include_once ("./model/Genre.php");
  include_once ("./util/DbUtil.php");

  class GenreEditController implements IController {
    public function execute(&$errors) {
      $id = $_REQUEST['id'];
      $genre = null;

      if (isSet($id)) {
        $query = "SELECT genre_id, genre_name FROM manga_genre" .
                " WHERE genre_id = $id";

        $dao = DbUtil::getDao();
        $result = $dao->query($query);

        $genre = new Genre($result[0]);
      } else {
        $genre = new Genre(null);
      }

      return $genre;
    }

    public function save(&$errors) {
      $id = $_REQUEST['id'];
      $dialect = DbUtil::getDialect();

      $name = $dialect->escapeString($_REQUEST['name']);

      $genre = new Genre(null);
      $genre->setId($id);
      $genre->setName($_REQUEST['name']);

      if ($name == "") {
        $errors->addError(new Error("name", AbstractLocale::getInstance()->getTranslation("error_required_name")));
      }


      $dao = DbUtil::getDao();
      if ($errors->hasErrors() == FALSE) {
        $query = "SELECT COUNT(*) AS count FROM manga_genre WHERE genre_name = '$name'";
        if (isSet($id) && $id != "") {
          $query .= " AND genre_id <> $id;";
        }
        $countResult = $dao->query($query);
        $count = $countResult[0]->count;

        if($count > 0) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_duplicate_reference")));
        }
      }

      if ($errors->hasErrors() == false) {
        $query = "";
        if (isSet($id) && $id != "") {
          $query = "UPDATE manga_genre " .
                  "SET genre_name = '$name' " .
                  "WHERE genre_id = $id;";
        } else {
          $query = "INSERT INTO manga_genre (genre_name) values (" .
                   "'$name');";
        }

        try {
          $dao->queryUpdate($query);
          $dao->commit();
        } catch(Exception $exception) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_save")));
          $dao->rollback();
        }
      }
      return $genre;
    }

  }
?>