<?php
  include_once ("./controller/IController.php");
  include_once ("./model/Genre.php");
  include_once ("./util/DbUtil.php");

  class GenreListController implements IController {
    public function execute(&$errors) {
      $genres = array();
      $dao = DbUtil::getDao();

      $genreRows = $dao->query("SELECT genre_id, genre_name FROM manga_genre ORDER BY genre_name;");
      foreach($genreRows as $genreRow) {
        $genreObject = new Genre($genreRow);
        $mangaCountRows = $dao->query("SELECT count(*) AS count FROM manga_title_genre WHERE genre_id = " . $genreObject->getId() . ";");
        $genreObject->setMangaCount($mangaCountRows[0]->count);

        array_push($genres, $genreObject);
      }
      return $genres;
    }

    public function delete(&$errors) {
      $result = null;

      $massDelete = $_REQUEST['massDelete'];
      if (count($massDelete) > 0) {
        $ids = "";
        foreach($massDelete as $id) {
          if ($ids != "") {
            $ids .= ", ";
          }
          $ids .= $id;
        }

        $dao = DbUtil::getDao();
        try {
          $dao->queryUpdate("DELETE FROM manga_genre WHERE genre_id in (" . $ids . ");");
          $dao->commit();
        } catch(Exception $exception) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_delete")));
          $dao->rollback();
          $result = $this->execute($errors);
        }
      }
      return $result;
    }
  }
?>