<?php
  include_once ("./controller/IController.php");
  include_once ("./model/Language.php");
  include_once ("./util/DbUtil.php");

  class LanguageEditController implements IController {
    public function execute(&$errors) {
      $id = $_REQUEST['id'];
      $language = null;

      if (isSet($id)) {
        $query = "SELECT language_id, language_name FROM manga_language" .
                " WHERE language_id = $id";

        $dao = DbUtil::getDao();
        $result = $dao->query($query);

        $language = new Language($result[0]);
      } else {
        $language = new Language(null);
      }

      return $language;
    }

    public function save(&$errors) {
      $id = $_REQUEST['id'];
      $dialect = DbUtil::getDialect();

      $name = $dialect->escapeString($_REQUEST['name']);

      $language = new Language(null);
      $language->setId($id);
      $language->setName($_REQUEST['name']);

      if ($name == "") {
        $errors->addError(new Error("name", AbstractLocale::getInstance()->getTranslation("error_required_name")));
      }

      $dao = DbUtil::getDao();
      if ($errors->hasErrors() == FALSE) {
        $query = "SELECT COUNT(*) AS count FROM manga_language WHERE language_name = '$name'";
        if (isSet($id) && $id != "") {
          $query .= " AND language_id <> $id;";
        }
        $countResult = $dao->query($query);
        $count = $countResult[0]->count;

        if($count > 0) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_duplicate_reference")));
        }
      }

      if ($errors->hasErrors() == false) {
        $query = "";
        if (isSet($id) && $id != "") {
          $query = "UPDATE manga_language " .
                  "SET language_name = '$name' " .
                  "WHERE language_id = $id;";
        } else {
          $query = "INSERT INTO manga_language (language_name) values (" .
                   "'$name');";
        }

        try {
          $dao->queryUpdate($query);
          $dao->commit();
        } catch(Exception $exception) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_save")));
          $dao->rollback();
        }
      }

      return $language;
    }
  }
?>