<?php
  include_once ("./controller/IController.php");
  include_once ("./model/Manga.php");
  include_once ("./util/DbUtil.php");

  class MangaListController implements IController {
    public function execute(&$errors) {
      $mangas = array();
      $dao = DbUtil::getDao();

      $mangasRows = $dao->query("SELECT title_id, title_name, title_original_name, title_original_name_romanji, title_rating, " .
                               "title_volume_count FROM manga_title ORDER BY title_name;");
      foreach($mangasRows as $mangaRow) {
        $mangaObject = new Manga($mangaRow, null);

        $countResult = $dao->query("SELECT COUNT(*) AS count FROM manga_volume WHERE title_id = " . $mangaObject->getId() .
                                    " AND volume_owned = TRUE AND volume_nr BETWEEN 1 AND " . $mangaObject->getVolumeCount() . ";");
        $mangaObject->setVolumesOwned($countResult[0]->count);

        array_push($mangas, $mangaObject);
      }

      $countResult = $dao->query("SELECT COUNT(*) AS count FROM manga_title;");
      $mangaCount = $countResult[0]->count;
      $countResult = $dao->query("SELECT COUNT(*) AS count FROM manga_volume;");
      $volumeTotal = $countResult[0]->count;
      $countResult = $dao->query("SELECT COUNT(*) AS count FROM manga_volume WHERE volume_owned = TRUE;");
      $volumeOwned = $countResult[0]->count;
      $GLOBALS['mangaCountInfo'] = $mangaCount;    
      $GLOBALS['volumeCountInfo'] = $volumeOwned . "/" . $volumeTotal;

      return $mangas;
    }

    public function delete(&$errors) {
      $massDelete = $_REQUEST['massDelete'];
      $result = null;

      if (count($massDelete) > 0) {
        $dao = DbUtil::getDao();

        try {
          foreach($massDelete as $id) {
            $volumeIds = "";
            $volumeIdsResult = $dao->query("SELECT volume_id FROM manga_volume WHERE title_id = $id;");
            foreach($volumeIdsResult as $result) {
              if($volumeIds !== "") {
                $volumeIds .= ", ";
              }
              $volumeIds .= $result->volume_id;
            }
          
            if($volumeIds != "") {
            	$dao->queryUpdate("DELETE FROM manga_volume_images WHERE volume_id in($volumeIds);");
            }
            $dao->queryUpdate("DELETE FROM manga_volume WHERE title_id = $id;");
            $dao->queryUpdate("DELETE FROM manga_title_genre WHERE title_id = $id;");
            $dao->queryUpdate("DELETE FROM manga_title WHERE title_id = $id;");
          }
        } catch(Exception $exception) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_delete")));
          $dao->rollback();
        }
        $dao->commit();
      }
      $result = $this->execute($errors);
      return $result;
    }
  }
?>