<?php
  include_once ("./controller/IController.php");
  include_once ("./util/DbUtil.php");
  include_once ("./model/Publisher.php");

  class PublisherEditController implements IController {
    public function execute(&$errors) {
      $id = $_REQUEST['id'];
      $publisher = null;

      if (isSet($id)) {
        $query = "SELECT publisher_id, publisher_name, publisher_website FROM manga_publisher" .
                " WHERE publisher_id = $id";

        $dao = DbUtil::getDao();
        $result = $dao->query($query);

        $publisher = new Publisher($result[0]);
      } else {
        $publisher = new Publisher(null);
      }

      return $publisher;
    }

    public function save(&$errors) {
      $id = $_REQUEST['id'];
      $dialect = DbUtil::getDialect();

      $name = $dialect->escapeString($_REQUEST['name']);
      $website = $dialect->escapeString($_REQUEST['website']);

      $publisher = new Publisher(null);
      $publisher->setId($id);
      $publisher->setName($_REQUEST['name']);
      $publisher->setWebsite($_REQUEST['website']);

      if ($name == "") {
        $errors->addError(new Error("name", AbstractLocale::getInstance()->getTranslation("error_required_name")));
      }

      $dao = DbUtil::getDao();
      if ($errors->hasErrors() == FALSE) {
        $query = "SELECT COUNT(*) AS count FROM manga_publisher WHERE publisher_name = '$name'";
        if (isSet($id) && $id != "") {
          $query .= " AND publisher_id <> $id;";
        }
        $countResult = $dao->query($query);
        $count = $countResult[0]->count;

        if($count > 0) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_duplicate_reference")));
        }
      }

      if ($errors->hasErrors() == false) {
        $query = "";
        if (isSet($id) && $id != "") {
          $query = "UPDATE manga_publisher " .
                  "SET publisher_name = '$name', " .
                  "publisher_website = '$website' " .
                  "WHERE publisher_id = $id;";
        } else {
          $query = "INSERT INTO manga_publisher (publisher_name, publisher_website) values (" .
                   "'$name', '$website');";
        }

        try {
          $dao->queryUpdate($query);
          $dao->commit();
        } catch(Exception $exception) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_save")));
          $dao->rollback();
        }
      }
      return $publisher;
    }
  }
?>