<?php
  include_once ("./controller/IController.php");
  include_once ("./util/DbUtil.php");
  include_once ("./model/Publisher.php");

  class PublisherListController implements IController {
    public function execute(&$errors) {
      $publishers = array();
      $dao = DbUtil::getDao();

      $publisherRows = $dao->query("SELECT publisher_id, publisher_name, publisher_website FROM manga_publisher ORDER BY publisher_name;");
      foreach($publisherRows as $publisherRow) {
        $publisherObject = new Publisher($publisherRow);
        $mangaCountRows = $dao->query("SELECT count(*) AS count FROM manga_title WHERE publisher_id = " . $publisherObject->getId() . ";");
        $publisherObject->setMangaCount($mangaCountRows[0]->count);

        array_push($publishers, $publisherObject);
      }
      return $publishers;
    }

    public function delete(&$errors) {
      $result = null;
      $massDelete = $_REQUEST['massDelete'];

      if (count($massDelete) > 0) {
        $ids = "";
        foreach($massDelete as $id) {
          if ($ids != "") {
            $ids .= ", ";
          }
          $ids .= $id;
        }

        $dao = DbUtil::getDao();
        try {
          $dao->queryUpdate("DELETE FROM manga_publisher WHERE publisher_id in (" . $ids . ");");
          $dao->commit();
        } catch(Exception $exception) {
          $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_delete")));
          $dao->rollback();
          $result = $this->execute($error);
        }
      }
      return $result;
    }
  }
?>