<?php
  include_once ("./controller/IController.php");

  class ReferenceData {
    private $title;
    private $action;

    function __construct($title, $action) {
      $this->action = $action;
      $this->title = AbstractLocale::getInstance()->getTranslation($title);
    }

    public function getTitle() {
      return $this->title;
    }

    public function getAction() {
      return $this->action;
    }
  }

  class ReferenceListController implements IController {
    public function execute(&$errors) {
      $references = array( new ReferenceData("list.author", "authorList"),
                    new ReferenceData("list.genre", "genreList"),
                    new ReferenceData("list.language", "languageList"),
                    new ReferenceData("list.publisher", "publisherList")
                  );
      sort($references);
      return $references;
    }
  }
?>