<?php
  include_once ("./controller/IController.php");
  include_once ("./util/DbUtil.php");
  include_once ("./model/Releases.php");

  class ReleasesController implements IController {
    public function execute(&$errors) {
      $dao = DbUtil::getDao();
      $releases = new Releases();
      $years = array();
      
      $query = "SELECT DISTINCT YEAR(volume_release) AS year FROM manga_volume WHERE volume_release IS NOT NULL ORDER BY year DESC;";
      
      $yearRows = $dao->query($query);
      foreach($yearRows as $yearRow) {
        $year = $yearRow->year;
        array_push($years, $year);
      }
      $releases->setYearList($years);
      
      
      if(isSet($_REQUEST['year'])) {
        $year = $_REQUEST['year'];
      } else if(count($years) > 0) {
        $year = $years[0];
      }
      
      if(isSet($year) && in_array($year, $years) ==  FALSE) {
        if(count($years) > 0) {
	  $year = $years[0];
        }
      }
      
      $releases->setYear($year);
    
      if(isSet($year)) {
        $query = "SELECT manga_title.title_name, manga_volume.volume_nr, manga_volume.volume_release FROM manga_volume INNER JOIN manga_title ON manga_volume.title_id = manga_title.title_id " .
                 "WHERE manga_volume.volume_release IS NOT NULL AND YEAR(manga_volume.volume_release ) = $year " .
                 "ORDER BY manga_title.title_name, manga_volume.volume_nr;";
                 
        $results = $dao->query($query);
        $datesMangas = array();
        foreach($results as $result) {
          $volumeRelease = str_replace("-", "", $result->volume_release);
          $volumeName = $result->title_name . " " . $result->volume_nr;
          
          if(isSet($datesMangas[$volumeRelease])) {
            $volumeList = $datesMangas[$volumeRelease];
          } else {
            $volumeList = array();
          }
          array_push($volumeList, $volumeName);
          $datesMangas[$volumeRelease] = $volumeList;
          
        }
        $releases->setDatesMangas($datesMangas);
      }
    
      return $releases;
    }
  }
?>