<?php
  include_once ("./controller/IController.php");
  include_once ("./model/Search.php");
  include_once ("./model/Author.php");
  include_once ("./model/Genre.php");
  include_once ("./model/Publisher.php");
  include_once ("./model/Language.php");
  include_once ("./util/DbUtil.php");

  class SearchController implements IController {
    public function execute(&$errors) {
      $search = new Search();
      
      $search->setAuthorList($this->getAuthors($errors));
      $search->setGenreList($this->getGenres($errors));
      $search->setPublisherList($this->getPublishers($errors));
      $search->setLanguageList($this->getLanguages($errors));
    
    
      return $search;
    }
    
    public function search(&$errors) {
    }
    
    private function getAuthors(&$errors) {
      $authors = array();
      $dao = DbUtil::getDao();

      $authorRows = $dao->query("SELECT author_id, author_name_romanji, author_name FROM manga_author ORDER BY author_name_romanji;");
      foreach($authorRows as $authorRow) {
        $authorObject = new Author($authorRow);
        array_push($authors, $authorObject);
      }
      return $authors;
    }
    
    private function getGenres(&$errors) {
      $genres = array();
      $dao = DbUtil::getDao();

      $genreRows = $dao->query("SELECT genre_id, genre_name FROM manga_genre ORDER BY genre_name;");
      foreach($genreRows as $genreRow) {
        $genreObject = new Genre($genreRow);
        array_push($genres, $genreObject);
      }
      return $genres;
    }
    
    private function getPublishers(&$errors) {
      $publishers = array();
      $dao = DbUtil::getDao();

      $publisherRows = $dao->query("SELECT publisher_id, publisher_name, publisher_website FROM manga_publisher ORDER BY publisher_name;");
      foreach($publisherRows as $publisherRow) {
        $publisherObject = new Publisher($publisherRow);
        array_push($publishers, $publisherObject);
      }
      return $publishers;
    }
    
    private function getLanguages(&$errors) {
      $languages = array();
      $dao = DbUtil::getDao();

      $languageRows = $dao->query("SELECT language_id, language_name FROM manga_language ORDER BY language_name;");
      foreach($languageRows as $languageRow) {
        $languageObject = new Language($languageRow);
        array_push($languages, $languageObject);
      }
      return $languages;
    }

  }
?>