<?php
  include_once ("./controller/MangaListController.php");
  include_once ("./model/Manga.php");
  include_once ("./util/DbUtil.php");

  class SearchMangaController extends MangaListController {
    public function execute(&$errors) {
      if(isSet($_REQUEST['mangaName'])) {
        $mangaName = $_REQUEST['mangaName'];
      }
      if(isSet($_REQUEST['authorId'])) {
        $authorId = $_REQUEST['authorId'];
      }
      if(isSet($_REQUEST['genreId'])) {
        $genreId = $_REQUEST['genreId'];
      }
      if(isSet($_REQUEST['publisherId'])) {
        $publisherId = $_REQUEST['publisherId'];
      }
      if(isSet($_REQUEST['languageId'])) {
        $languageId = $_REQUEST['languageId'];
      }  
    
      $query = "SELECT distinct manga_title.title_id, manga_title.title_name, manga_title.title_original_name, manga_title.title_original_name_romanji, manga_title.title_volume_count, manga_title.title_rating " .
               "FROM manga_title";
      
      if(isSet($genreId) && $genreId != '') {
        $query .= ", manga_title_genre" ;
      }
      
      $where = "";
      
      if(isSet($authorId) && $authorId != '') {
       $where = " WHERE author_id = $authorId";
      }
      
      if(isSet($publisherId) && $publisherId != '') {
        if($where == '') {
          $where = " WHERE";
        } else {
          $where .= " AND";
        }
        $where .= " publisher_id = $publisherId";
      }
      
      if(isSet($languageId) && $languageId != '') {
        if($where == '') {
          $where = " WHERE";
        } else {
          $where .= " AND";
        }
        $where .= " language_id = $languageId";
      }
      
      if(isSet($genreId) && $genreId != '') {
        if($where == '') {
          $where = " WHERE";
        } else {
          $where .= " AND";
        }
        $where .= " manga_title_genre.title_id = manga_title.title_id AND manga_title_genre.genre_id = $genreId";
      }
      
      if(isSet($mangaName) && $mangaName != '') {
        if($where == '') {
          $where = " WHERE";
        } else {
          $where .= " AND";
        }
        $where .= " manga_title.title_name like '%$mangaName%'";
      }
      
    
      $query = $query . $where . " ORDER BY title_name;";
    
      $mangas = array();
      $dao = DbUtil::getDao();

      $mangasRows = $dao->query($query);
      
      foreach($mangasRows as $mangaRow) {
        $mangaObject = new Manga($mangaRow, null);
        $countResult = $dao->query("SELECT COUNT(*) AS count FROM manga_volume WHERE title_id = " . $mangaObject->getId() .
                                    " AND volume_owned = TRUE AND volume_nr BETWEEN 1 AND " . $mangaObject->getVolumeCount() . ";");
        $mangaObject->setVolumesOwned($countResult[0]->count);
        array_push($mangas, $mangaObject);
      }
      $GLOBALS['mangaCountInfo'] = count($mangas);    
      return $mangas;
    }
  }
?>