<?php
  include_once ("./controller/IController.php");
  include_once ("./util/DbUtil.php");
  include_once ("./model/Volume.php");

  class VolumeListController implements IController {
    public function execute(&$errors) {
      $volumes = array();
      $titleId = $_REQUEST['titleId'];

      $dao = DbUtil::getDao();
      $volumeRows = $dao->query("SELECT volume_id, volume_nr, volume_owned, volume_release, volume_delayed, volume_isbn, title_id " .
                               "FROM manga_volume WHERE title_id = $titleId ORDER BY volume_nr;");
      foreach($volumeRows as $volumeRow) {
        array_push($volumes, new Volume($volumeRow));
      }
      return $volumes;
    }

    public function save(&$errors) {
      $result = null;
      $volumesId = $_REQUEST['id'];

      $dao = DbUtil::getDao();
      try {
        foreach($volumesId as $volumeId) {
          $owned = 0;
          if (isSet($_REQUEST["owned_$volumeId"])) {
            $owned = $_REQUEST["owned_$volumeId"];
          }
          if ($owned == "") {
            $owned = 0;
          }

          $delayed = 0;
          if (isSet($_REQUEST["delayed_$volumeId"])) {
            $delayed = $_REQUEST["delayed_$volumeId"];
          }
          if ($delayed == "") {
            $delayed = 0;
          }

          $query = "UPDATE manga_volume " .
                    "SET volume_owned = $owned, " .
                    "volume_delayed = $delayed " .
                    "WHERE volume_id = $volumeId;";

          $dao->queryUpdate($query);
        }
      } catch(Exception $exception) {
        $errors->addError(new Error(Error::$GLOBAL_ERROR, AbstractLocale::getInstance()->getTranslation("error_save")));
        $dao->rollback();
        $result = $this->execute($errors);
      }
      $dao->commit();

      return $result;
    }
  }
?>