<?php
  include_once ("./util/DbUtil.php");
  include_once ("./util/Utils.php");

  class Volume {
    private $id;
    private $titleId;
    private $number;
    private $owned;
    private $releaseDate;
    private $delayed;
    private $isbn;
    
    private $imageIds;

    public function __construct($volumeObject) {
      if (isSet($volumeObject)) {
        $this->id = $volumeObject->volume_id;
        $this->titleId = $volumeObject->title_id;
        $this->number = $volumeObject->volume_nr;
        $this->owned = $volumeObject->volume_owned;
        $this->releaseDate = Utils::timestampToDate(DbUtil::getDialect()->dateToTimestamp($volumeObject->volume_release));
        $this->isbn = $volumeObject->volume_isbn;
        $this->delayed = $volumeObject->volume_delayed;
      }
    }

    public function getId() {
      return $this->id;
    }
    
    public function setId($id) {
      $this->id = $id;
    }
    
    public function getTitleId() {
      return $this->titleId;
    }
    
    public function setTitleId($titleId) {
      $this->titleId = $titleId;
    }

    public function getNumber() {
      return $this->number;
    }

    public function setNumber($number) {
      $this->number = $number;
    }

    public function getOwned() {
      return $this->owned;
    }

    public function setOwned($owned) {
      $this->owned = $owned;
    }

    public function getReleaseDate() {
      return $this->releaseDate;
    }

    public function setReleaseDate($releaseDate) {
      $this->releaseDate = $releaseDate;
    }

    public function getDelayed() {
      return $this->delayed;
    }

    public function setDelayed($delayed) {
      $this->delayed = $delayed;
    }
    
    public function getIsbn() {
      return $this->isbn;
    }
    
    public function setIsbn($isnb) {
      $this->isnb = $isbn;
    }
    
    public function getImageIds() {
      return $this->imageIds;
    }
    
    public function setImageIds($imageIds) {
      $this->imageIds = $imageIds;
    }
    
  }
?>