<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml/DTD/xhtml-strict.dtd">
<?php global $theme;?>
<html>
    <head>
        <title><?php if(isSet($title)) { echo $title; }?></title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <link rel="shortcut icon" href="./themes/<?php echo($theme);?>/images/favico.ico" />
        <link rel="stylesheet" href="./themes/<?php echo($theme);?>/style.css" type="text/css"/>
        <script type="text/javascript" src="scripts/form.js" ></script>
    </head>

    <body onload="setFirstFieldFocus();">
        <div class="banner"></div>
        
        <div class="themeSelect">
          <form name="selectTheme" action="<?php echo("http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']); ?>" method="post">
            <select name="newTheme" onchange="window.document.selectTheme.submit(); return false;">
              <?php
                $dirs = scanDir("./themes");
                foreach($dirs as $dir) {
                  if($dir != "." && $dir != "..") {
                    $selected = "";
                    if($dir == $theme) {
                      $selected = "selected='selected'";
                    }
                    echo ("<option value='$dir' $selected>$dir</option>");
                  }
                }
              ?>
            </select>
          </form>
        </div>
        
        <div class="breadcrumb">
          <?php
            include ("./view/breadcrumb.php");
            $breadcrumb = new BreadCrumb();
            echo $breadcrumb->createBreadCrumb();
          ?>
        </div>
        <!-- onglets -->
        <div class="tabGroup">
            <div class="<?php if($selectedTab != 1) { echo 'un';} ?>selectedTab clickable" id="manga_tab1" onclick="window.location='index.php?do=mangaList'">
                <div class="roundl3"></div>
                <div class="roundl2"></div>
                <div class="roundl1"></div>
                <div class="tabLabel"><a href="#"><?php echo AbstractLocale::getInstance()->getTranslation("tab.mangas"); ?></a></div>
                <div class="roundl1"></div>
                <div class="roundl2"></div>
                <div class="roundl3"></div>
                <div class="tabSeparator"></div>
            </div>
            
            <div class="<?php if($selectedTab != 2) { echo 'un';} ?>selectedTab clickable" id="manga_tab2" onclick="window.location='index.php?do=referenceList'">
                <div class="roundl3"></div>
                <div class="roundl2"></div>
                <div class="roundl1"></div>
                <div class="tabLabel"><a href="#"><?php echo AbstractLocale::getInstance()->getTranslation("tab.references"); ?></a></div>
                <div class="roundl1"></div>
                <div class="roundl2"></div>
                <div class="roundl3"></div>
                <div class="tabSeparator"></div>
            </div>

            <div class="<?php if($selectedTab != 3) { echo 'un';} ?>selectedTab clickable" id="manga_tab3" onclick="window.location='index.php?do=searchCriteria'">
                <div class="roundl3"></div>
                <div class="roundl2"></div>
                <div class="roundl1"></div>
                <div class="tabLabel"><a href="#"><?php echo AbstractLocale::getInstance()->getTranslation("tab.search"); ?></a></div>
                <div class="roundl1"></div>
                <div class="roundl2"></div>
                <div class="roundl3"></div>
                <div class="tabSeparator"></div>
            </div>

            <div class="<?php if($selectedTab != 4) { echo 'un';} ?>selectedTab clickable" id="manga_tab4" onclick="window.location='index.php?do=releases'">
                <div class="roundl3"></div>
                <div class="roundl2"></div>
                <div class="roundl1"></div>
                <div class="tabLabel"><a href="#"><?php echo AbstractLocale::getInstance()->getTranslation("tab.releases"); ?></a></div>
                <div class="roundl1"></div>
                <div class="roundl2"></div>
                <div class="roundl3"></div>
                <div class="tabSeparator"></div>
            </div>
        </div>
        
        <!-- Partie saisie de donnees -->
        <div class="dataPanel <?php if(isSet($actionsPage)) { echo 'withactions';} else { echo 'noactions';}?>">
            <div class="roundlr3 frameBorder"></div>
            <div class="roundlr2 frameBorderlr"></div>
            <div class="roundlr1 frameBorderlr"></div>

            <div class="actionsPanelContainer frameBorderlr">
                <div id="actionsPanel" class="actionsPanel">
                  <?php
                    if (isSet($actionsPage)) {
                      include($actionsPage);
                    }
                  ?>
                </div>
            </div>
            
            <div class="borderFormPanel frameBorderlr">
                <!-- form -->
                <div id="formPanel" class="formPanel">
                  <?php
                    global $errors;
                    if (isSet($errors)) {
                      $error = $errors->getGlobalError();
                      if (isSet($error)) {
                        echo ("<div class=\"errorPanel\">" . $error->getMessage() . "</div>");
                      }
                    }
                    include($formPage);
                  ?>
                </div>
            </div>

            <div class="bottomDataPanel">
                <div class="roundlr1 frameBorderlr"></div>
                <div class="roundlr2 frameBorderlr"></div>
                <div class="roundlr3 frameBorder"></div>
            </div>
        </div>
    </body>
</html>