<?php
  class HTML {
    public static function createURL($urlTemplate) {
      $url = $urlTemplate;
    
      $pos1 = strpos($url, "{");
      while($pos1 !== FALSE) {
        $pos2 = strpos($url, "}", $pos1 + 1);
        
        if ($pos2 !== FALSE) {
          $var = substr($url, $pos1 + 1, $pos2 - $pos1 - 1);
          
          $url = substr_replace ($url, $_REQUEST["$var"], $pos1, $pos2 - $pos1 + 1);
        }
        
        $pos1 = strpos($url, "{");
      }
      return $url;
    }

    public static function createLabel($display, $field, $errors) {
      $error = null;
      
      if (isSet($errors) && isSet($field)) {
        $error = $errors->getFieldError($field);
      }

      echo "<label class=\"field";
      if ($error != null) {
        echo " fieldError";
      }
      echo "\"";

      if (isSet($field)) {
        echo " for=\"$field\"";
      }

      if ($error != null) {
        echo "title=\"" . $error->getMessage() . "\"";
      }
      echo ">$display</label>";
    }

    public static function createInputField($field, $value, $maxLength, $mandatory) {
      echo "<input type=\"text\" class=\"field\" id=\"$field\" name=\"$field\"";
      if (isSet($value)) {
        echo " value=\"$value\"";
      }
      if (isSet($maxLength)) {
        echo " maxlength=\"$maxLength\"";
      }
      echo "/>";

      if (isSet($mandatory) && $mandatory == TRUE) {
        echo "<div class=\"mandatory\">*</div>";
      }
    }

    public static function createTextArea($field, $cols, $rows, $value) {
      echo "<textarea class=\"field\" name=\"$field\"";
      if (isSet($cols)) {
        echo " cols=\"$cols\"";
      }
      if (isSet($rows)) {
        echo " rows=\"$rows\"";
      }
      echo ">";
      if (isSet($value)) {
        echo $value;
      }
      echo "</textarea>";
    }
    
    public static function createSimpleSelect($field, $value, $list, $addEmptyRow, $onChange) {
      echo "<select name=\"$field\" id=\"$field\" class=\"field\"";
      
      if(isSet($onChange) && $onChange != '') {
        echo ("onchange='$onChange'");
      }
      echo (">");
      
      
      if ($addEmptyRow === TRUE) {
        echo "<option value=\"\" >&nbsp;</option>";
      }
      
      foreach($list as $obj) {
        $idValue = $obj;
        $labelValue = $obj;
        
        echo "<option value=\"$obj\"";
        if ($idValue == $value) {
          echo " selected=\"selected\"";
        }
        echo ">$obj</option>";
      }
      echo "</select>";
    }    
    
    public static function createSelect($field, $value, $list, $id, $label, $label2, $addEmptyRow) {
      $addLabel2 = FALSE;
      $label2Value = "";
      
      if (isSet($label2) && $label2 != "") {
        $addLabel2 = TRUE;
      }
    
      if ($addLabel2 === TRUE) {
        echo "\n<script type=\"text/javascript\">\n";
        echo "var " . $field . "_values = {";
        
        $isFirst = TRUE;
        foreach($list as $obj) {
          $className = get_class($obj);
          $reflectionClass = new ReflectionClass($className);
          $reflectionMethodId = $reflectionClass->getMethod($id);
          $reflectionMethodLabel2 = $reflectionClass->getMethod($label2);

          $idValue = $reflectionMethodId->invoke($obj);
          $labelValue2 = $reflectionMethodLabel2->invoke($obj);
          
          if ($isFirst === FALSE) {
            echo ", ";
          } else {
            $isFirst = FALSE;
          }
          echo $idValue . ": \"" . $labelValue2 . "\"";
        }
        echo "};\n";

        echo "function selectLabel2_" . $field . "_onchange() {\n";
        echo "var selectElem = window.document.getElementById(\"$field\");\n";
        echo "var labelElem = window.document.getElementById(\"selectLabel2_$field\");\n";

        echo "while (labelElem.hasChildNodes()) {\n";
    		echo " labelElem.removeChild(labelElem.firstChild);\n}\n";

        echo "var value = " . $field . "_values[selectElem.value];\n";
        echo "labelElem.className=\"selectLabel2\";\n";
        echo "if (typeof(value) == \"undefined\" || value == \"\") {";
        echo " value = \"\";\n";
        echo "labelElem.className=\"hidden\";\n";
        echo "};\n";
        echo "var text = window.document.createTextNode(value);\n";

        echo "labelElem.appendChild(text);\n";

        echo "}\n";
        echo "</script>\n";
      }

      echo "<select name=\"$field\" id=\"$field\" class=\"field\" ";
      if ($addLabel2 === TRUE) {
        echo "onchange=\"selectLabel2_" . $field . "_onchange();\" ";
      }
      echo ">";
      
      if ($addEmptyRow === TRUE) {
        echo "<option value=\"\" >&nbsp;</option>";
      }
      
      foreach($list as $obj) {
        $className = get_class($obj);
        $reflectionClass = new ReflectionClass($className);
        $reflectionMethodId = $reflectionClass->getMethod($id);
        $reflectionMethodLabel = $reflectionClass->getMethod($label);
        
        $idValue = $reflectionMethodId->invoke($obj);
        $labelValue = $reflectionMethodLabel->invoke($obj);
        
        echo "<option value=\"$idValue\"";
        if ($idValue == $value) {
          echo " selected=\"selected\"";
          
          if ($addLabel2 === TRUE) {
            $reflectionMethodLabel2 = $reflectionClass->getMethod($label2);
            $label2Value = $reflectionMethodLabel2->invoke($obj);
          }
        }
        echo ">$labelValue</option>";
      }
      echo "</select>";
      
      if ($addLabel2 === TRUE) {
        $label2Class = "selectLabel2";
        if (!isSet($label2Value) || $label2Value == "") {
          $label2Class = "hidden";
        }
        echo "<div id=\"selectLabel2_$field\" class=\"$label2Class\">$label2Value</div>";
      }
    }
    
    public static function createCheckbox($field, $value, $checked) {
      echo "<input type=\"checkbox\" class=\"checkboxField\" value=\"$value\" name=\"$field\"";
      if($checked == TRUE) {
        echo " checked=\"checked\"";
      }
      echo "/>";
    }
    
    public static function createMultiCheckbox($field, $values, $list, $id, $label) {
      echo "<div class=\"multiSelect\">";
      
      foreach($list as $obj) {
        $className = get_class($obj);
        $reflectionClass = new ReflectionClass($className);
        $reflectionMethodId = $reflectionClass->getMethod($id);
        $reflectionMethodLabel = $reflectionClass->getMethod($label);

        $idValue = $reflectionMethodId->invoke($obj);
        $labelValue = $reflectionMethodLabel->invoke($obj);
        
        echo "<input type=\"checkbox\" name=\"$field\" value=\"$idValue\"";
        if (in_array($idValue, $values)) {
          echo "checked=\"checked\"";
        }
        echo "/>$labelValue<br />";
      }
      echo "</div>";
    }

  }
?>