<?php
  class Utils {
    public static function timestampToDate($timestamp) {
      $date = "";
      
      if(isSet($timestamp)) {
        $date = date(AbstractLocale::getInstance()->getDateFormat(), $timestamp);
      }
      return $date;
    }
    
    public static function checkDate($date) {
      $return = FALSE;
    
      if(isSet($date) && $date != '') {
        $dateValues = Utils::extractDate($date);
        if(isSet($dateValues[0]) && isSet($dateValues[1]) && isSet($dateValues[2]) && !isSet($dateValues[3])) {
          $return = checkdate($dateValues[1], $dateValues[0], $dateValues[2]);
        }
      } else {
        $return = TRUE; // no value = valid
      }

      return $return;
    }

    public static function dateToTimestamp($date) {
      $timestamp = NULL;
    
      if(isSet($date) && $date != '') {
        $dateValues = Utils::extractDate($date);
        if(isSet($dateValues[0]) && isSet($dateValues[1]) && isSet($dateValues[2]) && !isSet($dateValues[3])) {
          $timestamp = mktime(0, 0, 0, $dateValues[1], $dateValues[0], $dateValues[2]);
        }
      }
      
      return $timestamp;
    }
    
    private static function extractDate($date) {
      $return = FALSE;
      $format = AbstractLocale::getInstance()->getDateFormat();
      $extractFormat = str_replace(array("d", "j", "m", "n", "o", "Y", "y"), "%u", $format);

      $values = sscanf($date, $extractFormat . "%s");

      $count = strlen($format);
      $dayPos = NULL;
      $monthPos = NULL;
      $yearPos = NULL;

      $pos = 0;
      for($i = 0; $i < $count; $i++) {
        $str = substr($format, $i, 1);
        switch($str) {
          case "d":
          case "j":
            $dayPos = $pos++;
            break;
          case "m":
          case "n":
            $monthPos = $pos++;
            break;
          case "o":
          case "Y":
          case "y":
            $yearPos = $pos++;
        }
      }

      if(isSet($dayPos) && isSet($monthPos) && isSet($yearPos)) {
        $day = $values[$dayPos];
        $month = $values[$monthPos];
        $year = $values[$yearPos];
        
        $values[0] = $day;
        $values[1] = $month;
        $values[2] = $year;
        
        $return = $values;
      }

      return $return;
    }
  }
?>