<?php
  global $releases;
?>

<script type="text/javascript">
  var releases = new Array();
  var volumes;
  var currentCell = null;
  
  <?php
    foreach($releases->getDatesMangas() as $key => $releaseValues) {
      echo ("volumes = new Array();\n");
      foreach($releaseValues as $releaseValue) {
        echo ("volumes.push('" . $releaseValue . "');\n");
      }
      echo ("releases['" . $key . "'] = volumes;\n");
    }
  ?>
  
  function showReleases(dt, formattedDate, cell) {
    var mangasReleased = releases[dt];
    var txt = "";
    
    for (var i = 0; i < mangasReleased.length; i++) {
      var txt = txt + mangasReleased[i] + "<br />";
    }    
    
    var panel = window.document.getElementById("mangasReleaseText");
    panel.innerHTML = txt;
    
    var fielset = window.document.getElementById("mangasRelease");
    fielset.style.display = "block";
    
    var legend = window.document.getElementById("mangasReleaseLegend");
    var legendText = "<?php echo (AbstractLocale::getInstance()->getTranslation("label_releases")); ?> " + formattedDate;
    legend.innerHTML = legendText;
    
    cell.className = "releaseDay releaseDaySelected";
    if(currentCell != null) {
      currentCell.className = "releaseDay";
    }
    currentCell = cell;
  }
</script>


<form name="releases" method="post" action="index.php?do=releases" enctype="multipart/form-data; charset=UTF-8">
  <?php HTML::createSimpleSelect("year", $releases->getYear(), $releases->getYearList(), FALSE, "window.document.releases.submit(); return false;"); ?>
  <br style="clear: left"/>
  <br />

  <?php
    $year = $releases->getYear();

    if(isSet($year)) {
      $releasesCalendar = new ReleasesCalendar();

      for($month = 1; $month <= 12; $month++) {
        $releasesCalendar->generate($year, $month, $releases->getDatesMangas());
      }
    }
  ?>
  
  <br style="clear: left"/>
  <br />

  <fieldset id="mangasRelease" style="display: none">
    <legend id="mangasReleaseLegend"></legend>
    <div id="mangasReleaseText">
    </div>
  </fieldset>
</form>

<?php
  class ReleasesCalendar {
    public function generate($year, $month, $datesMangas) {
      $day = 1;
      
      echo ("<table class='releaseCalendar'>");
      echo ("<tr class='month'><td colspan='7'>");
      echo (AbstractLocale::getInstance()->getTranslation("label_month_" . $month));
      echo ("</td></tr>");
      
      echo("<tr class='days'>");
      for($i = 1; $i < 8; $i++) {
        echo ("<td>" . AbstractLocale::getInstance()->getTranslation("label_day_$i") . "</td>");
      }  
      echo ("</tr>");
      
      $date = mktime (0, 0, 0, $month, $day, $year);
      $nbWeek = 0;
      
      while(checkdate($month, $day, $year)) {
        $day = $this->generateWeek($day, $month, $year, $datesMangas);
        $nbWeek++;
      }
      
      while($nbWeek < 6) {
        echo ("<tr class='week'><td colspan='7'>&nbsp;</td></tr>");
        $nbWeek++;
      }
      
      
      echo ("</table>");
    }
    
    private function generateWeek($day, $month, $year, $datesMangas) {
      $date = mktime (0, 0, 0, $month, $day, $year);
      $mondayFirstDayWeek = AbstractLocale::getInstance()->isMondayFirstDayOfWeek();
      

      $dayOfWeek = date("w", $date);
      if($mondayFirstDayWeek == true) {
        if($dayOfWeek == 0) {
          $dayOfWeek = 7;
        }
      } else {
        $dayOfWeek++;
      }

      echo ("<tr class='week'>");

      if($dayOfWeek > 1) {
        echo ("<td colspan='" . ($dayOfWeek - 1) . "'></td>");
      }
      
      while($dayOfWeek <= 7 && checkdate($month, $day, $year)) {
        $currentDate = mktime(0, 0, 0, $month, $day, $year);
        $dateStr = date ("Ymd", $currentDate);
        $formattedDate = date(AbstractLocale::getInstance()->getDateFormat(), $currentDate);
      
        if(isSet($datesMangas[$dateStr])) {
          echo ("<td class='releaseDay' onclick='showReleases(\"$dateStr\", \"$formattedDate\", this)'>" . $day . "</td>");
        } else {
          echo ("<td>" . $day . "</td>");
        }
        $day++;
        $dayOfWeek++;
      }
      
      if($dayOfWeek < 8) {
        echo ("<td colspan='" . (8 - $dayOfWeek) . "'></td>");
      }
      
      echo ("</tr>");
      
      return $day;
    }
  }
?>